;; if set to false, optimum models are not prRealed out
(set-option:produce-models true)

(declare-fun x1 () Real)
(declare-fun x2 () Real)
(declare-fun x3 () Real)
(declare-fun x4 () Real)

(assert (< 0 x1))
(assert (< 0 x2))
(assert (< 0 x3))
(assert (< 0 x4))

(push 1)
(minimize (+ x1 x2 x3 x4) :local-ub 30)
(check-sat)
(set-model -1)
(get-value (x1))
(get-value (x2))
(get-value (x3))
(get-value (x4))
(get-value (cost_0))
(pop 1)

(push 1)
(minimize (+ (- x1) (- x2) (- x3) (- x4)) :local-lb -200 :local-ub -120)
(check-sat)
(set-model -1)
(get-value (x1))
(get-value (x2))
(get-value (x3))
(get-value (x4))
(get-value (cost_0))
(get-value (cost_1))
(pop 1)

; Minimization Works:
(minimize (+ x1 x2 x3 x4) :local-ub 30)
(minimize (+ (- x1) (- x2) (- x3) (- x4)) :local-lb -200 :local-ub -120)
(check-sat)
(set-model -2)
(get-value (x1))
(get-value (x2))
(get-value (x3))
(get-value (x4))
(get-value (cost_0))
(get-value (cost_1))
(get-value (cost_2))
(get-value (cost_3))

(set-model -1)
(get-model)
